
require 'mylib/console/console'
require 'game/game'
require 'mods/mods'

function love.load()
	console.init()
	game.load()
	mods.load()
end

function love.draw()
	mods.draw()
	game.draw()
	console.draw()
end

function love.update(dt)
	game.update(dt)
	mods.update(dt)
end

function love.keypressed(k)
	console.tInput(k)
	mods.input(k)
	game.input(k)
end