
--made by Doctory
require 'mylib/utf8'

console = {}
console.input = ""

console.init = function()
	font = love.graphics.newFont("game/font/coders_crux.ttf", 16)
	console.w = love.window.getWidth()
	console.h = 100
	console.canDraw = false
	console.text = ""
	console.lines = 0
	console.write("i", "Console initiation is done!")
end


console.draw = function()
	if console.canDraw then
		love.graphics.setColor(0, 0, 0, 120)
		love.graphics.rectangle("fill", 0, 0, console.w, console.h)
		love.graphics.setColor(0, 0, 0, 140)
		love.graphics.rectangle("fill", 0, 100, console.w, 22)
		love.graphics.setColor(255, 255, 255)
		love.graphics.setFont(font)
		love.graphics.print("> " .. console.input, 3, 106.5)
		love.graphics.print(console.text, 5, 5)
	end
end
	
console.write = function(t, msg)
	if t == "i" then
		console.text = console.text .. os.date("%X") .. " [I] " .. msg .. "\n"
	elseif t == "e" then
		console.text = console.text .. os.date("%X") .. " [E] " .. msg .. "\n"
	elseif t == "w" then
		console.text = console.text .. os.date("%X") .. " [W] " .. msg .. "\n"
	end
end
	
console.tInput = function(k)
	if k == "`" then
		console.canDraw = not console.canDraw
	end
	if console.canDraw then
		if k ~= "return" then
			if k ~= "`" then
				if k ~= "backspace" then
					console.input = console.input .. k
				else
					console.input = console.input:utf8sub(1, -2)
				end
			end
		elseif k == "return" then
			msg = console.input
			if msg == "/help" then
				console.write("i", "/quit - quit the game")
				console.write("i", "/cpu - bytes of memory being used")
				console.lines = console.lines + 1
			elseif msg == "/cpu" then
				console.write("i", tostring(collectgarbage("count")*1024))
				console.lines = console.lines + 1
			elseif msg == "/quit" then
				love.event.quit()
			else
				console.write("e", "no such command, type /help")
			end
			console.input = ""
			console.lines = console.lines + 1
			if console.lines >= 10 then
				console.lines = 0
				console.text = ""
			end
		end
	end
end


	

