
--made by Doctory
require 'mylib/console/utf8'

console = {}
console.commands = {}
printMsg = true
console.input = ""

console.init = function()
	font = love.graphics.newFont("mylib/console/coders_crux.ttf", 16)
	console.w = love.window.getWidth()
	console.h = 100
	console.canDraw = false
	console.text = ""
	console.lines = 0
	console.newCommand("/help", function() console.write("i", "nothing") end)
	console.write("i", "Console initiation is done!")
end

console.newCommand = function(name, action)
	table.insert(console.commands, {name = name, action = action})
end

console.draw = function()
	if console.canDraw then
		love.graphics.setColor(0, 0, 0, 120)
		love.graphics.rectangle("fill", 0, 0, console.w, console.h)
		love.graphics.setColor(0, 0, 0, 140)
		love.graphics.rectangle("fill", 0, 100, console.w, 22)
		love.graphics.setColor(255, 255, 255)
		love.graphics.setFont(font)
		love.graphics.print("> " .. console.input, 3, 106.5)
		love.graphics.print(console.text, 5, 5)
	end
end
	
console.write = function(t, msg)
	if t == "i" then
		console.text = console.text .. os.date("%X") .. " [Info] " .. msg .. "\n"
	elseif t == "e" then
		console.text = console.text .. os.date("%X") .. " [Error] " .. msg .. "\n"
	elseif t == "w" then
		console.text = console.text .. os.date("%X") .. " [Warning] " .. msg .. "\n"
	end
end
	
console.tInput = function(k)
	if k == "`" then
		console.canDraw = not console.canDraw
	end
	if console.canDraw then
		if k ~= "return" then
			if k ~= "`" then
				if k ~= "backspace" then
					console.input = console.input .. k
				else
					console.input = console.input:utf8sub(1, -2)
				end
			end
		elseif k == "return" then
			msg = console.input
			for k, v in ipairs(console.commands) do
				if msg == v.name then
					v.action()
					printMsg = false
				end
			end
			if printMsg == true then
				console.write("e", "No such command")
			end
			console.input = ""
			console.lines = console.lines + 1
			printMsg = true
			if console.lines >= 10 then
				console.lines = 0
				console.text = ""
			end
		end
	end
end


	

